//
//  Scene1000.m
//  Fiona's Walk
//
//  Created by Kyle Reynolds on 4/6/12.
//  Copyright (c) 2012 The Canvas Foundation. All rights reserved.
//

#import "Scene1000.h"

@implementation Scene1000

-(id)init {
    int point;
    
    BOOL clarkknockdowwn = NO;
    int  clarkknockdownpoint = 0;
    
    BOOL clarkhit = NO;
    int clarkhitpoint = 0;
    
    BOOL fionastop = NO;
    int fionastoppoint = 0;
    
    BOOL fionagrab = NO;
    int fionagrabpoint = 0;
    
    BOOL clarkout = NO;
    int clarkoutpoint = 0;
    
    int hatchoicepoint = 0;
    FWCondition* hat_condition = [[FWCondition alloc] load:@"1000_condition_hatchoice"];
    
    [FWLine scene:@"1000"];
    return [super init];
    sceneId = @"1000";
}

-(void)run {
    [FWLine scene:@"1000"];
    
    if(at == 0) {
        [FWPlayer lock];
        //spritesets will have clothing suffixes. note: NOT individual sprites, but spritesets. Or, a "pajamas spriteset" attribute per entity.
        [FWClothing changeEntity:@"clark" to:@"pajamas"];
        [FWClothing changeEntity:@"fiona" to:@"pajamas"];
    }
    
    //FWRunningSpeed sets overall movement speed for all actions.
    [FWRunningSpeed ofEntity:@"clark" isKMPerHour:10];
    [FWRunningSpeed ofEntity:@"fiona" isKMPerHour:18];
    
    //settable trustmeters is more a formality specifically between clark and fiona. FWConnection can be used for proximity of various objects in percentages rather than meters, but "trust" is the value that sets the camera field of view. All entities get a trust meter default of 100. 
    [FWConnection between:@"clark" and:@"fiona" setTrustMeters:30];
    
    [FWCinematography subject:@"fiona"]; //hmm... YES!
    
    if(at == 2000)
    [FWLogo show:@"logo_canvasprevents" ms: 7000];
    
    if(at == 9000) {
        //FWWake shows a wake/yawn sprite that leads all the way to a "bedhead" animation that goes away when the Character is moved.
        [FWWake sitUpEntity:@"clark"];
        [FWWake sitUpEntity:@"fiona"];
    }
    
    if(at == 12000) {
        [FWCustomSprite entity:@"clark" to:@"1000_clark_lay_lookleft"];
    }
    if(at == 14000) {
        [FWCustomSprite entity:@"clark" to:@"1000_clark_lay_smile"];
        [FWCustomSprite entity:@"fiona" to:@"1000_fiona_lay_lookleft"];
    }
    if(at == 17000)
        [FWCustomSprite entity:@"fiona" to:@"1000_fiona_lay_lookleft_frown"];
    if(at == 20000)
        [FWWake standUpEntity:@"fiona"];
    if(at == 21000)
        [FWDestination forEntity:@"fiona" isArea:@"fiona_clark_bathroom"];
    if(at == 22000)
        [FWLine display:@"1000"];
    
    if(at == 23000) {
        if([FWLocation area:@"fiona_clark_bathroom" has:@"fiona"]) {
            //FWUse also plays the entity's "use sound".
            point = at;
            [FWUse entityInProximity:@"1000_sink_faucet" by:@"fiona"];
        }
    }
    
    if(at == point+2000) {
        [FWLine display:@"2000"];
    }
    
    if(at == point+4000) {
        [FWHop toMarker:@"1000_marker_bedside" entity:@"clark"];
    }
    
    if(at == point+5500) {
        [FWCustomSprite entity:@"clark" to:@"1000_clark_shock"];
        [FWLine display:@"3000"];
    }
    
    if(at == point+6300) {
        [FWLine display:@"4000"];
    }
    
    if(at == point+7000)
        [FWPlayer unlock];
    
    if(at == point+8000)
        [FWSoundEffect play:@"1000_toothbrush"];
    if(at == point+8200) {
        [FWSoundEffect play:@"1000_flail"];
        [FWCustomSprite entity:@"fiona" to:@"1000_fiona_flail"];
    }
    if(at == point+8400) {
        [FWGrab entity:@"1000_hairbrush" by:@"fiona"];
        //FWThrow throws whatever posession an entity's holding.
        [FWThrow atEntity:@"clark" fromEntity:@"fiona"]; 
    }
    
    if(at > point+8500) { 
        //Clark is hit with the hairbrush.
        if([FWHit entityIsHit:@"clark" byEntityOfPrototype:@"brush"]) {
            clarkhitpoint = at;
            clarkhit = YES;
        }
    }
    
    if(clarkhit == YES) {
        if(at == clarkhitpoint+1000) {
            [FWLine display:@"4100"];
        }
        
        if(at == clarkhitpoint+3000) {
            [FWClothing closetChange:@"1000_closet_fionaclark" entity:@"fiona" to:@""];
        }
        
        if(at > clarkhitpoint+4000 && [FWConnection between:@"clark" and:@"fiona" isDistancePercent:5]) {
            [FWDestination forEntity:@"fiona" isMarker:@"1000_marker_hallway"];
            [FWHit obliviousShove:@"clark" by:@"fiona"];
            
            clarkknockdownpoint = at;
            clarkknockdown = YES;
        }
    }
    
    if(clarkknockdown == YES) {
        if([FWConnection between:@"clark" and:@"fiona" isDistancePercent:60]) {
            [FWLine display:@"5000"];
        }
        
        if([FWConnection between @"clark" and:@"fiona" isDistancePercent:90]) {
            [FWLine display:@"6000"];
            [FWDestination abruptStop:@"fiona"];
            fionastop = YES;
            fionastoppoint = at;
        }
    }
    
    if(fionastop == YES) {
        if(at == fionastoppoint+3000) {
            [FWFace entity:@"fiona" lookAt:@"1000_drawer"]
            [FWLine display:@"7000"];
        }
        
        if(at == fionastoppoint+5000) {
            [FWLine display:@"8000"];
        }
        
        if(at > fionastoppoint+8000 && [FWConnection between:@"clark" and:@"fiona" isDistancePercent:30]) {
            [FWGrab fromTable:@"1000_drawer" entity:@"1000_keys" by:@"fiona"];
            fionagrab = YES;
            fionagrabpoint = at;
        }
    }
    
    if(fionagrab == YES) {
        if(at == fionagrabpoint+2000) {
            //[FWFace entity:@"clark" reach:@"fiona"];
            [FWLine display:@"9000"];
        }
        
        if(at == fionagrabpoint+2400) {
            [FWDestination forEntity:@"fiona" isMarker:@"1000_marker_hatrack"];
        }
        
        if(at == fionagrabpoint+2500) {
            [FWPlayer lock];
            [FWClothing drawerChange:@"1000_drawer" entity:@"clark" to:@""];
        }
        
        if(at == fionagrabpoint+4000) {
            [FWPlayer unlock];
        }
        
        if([FWConnection between:@"clark" and:@"fiona" isDistancePercent:2]) {
            clarkout = YES;
            clarkoutpoint = at;
        }
    }
    
    if(clarkout == YES) {
        if(at == clarkout) {
            [FWCustomSprite entity:@"fiona" to:@"1000_fiona_think"];
        }
        
        if(at == clarkout+1000) {
            [FWLine display:@"10000"];
        }
        
        if(at == clarkout+3000) {
            [hat_condition addBehindEntity:@"hat_pink" inDirection:180 ofLine:@"11000"];
            [hat_condition addBehindEntity:@"hat_blue" inDirection:0 ofLine:@"12000"];
        }
        
        if([[hat_condition choice] != nil]) {
            hatchoicepoint = at;
            [hat_condition timeInSeconds:8]
        }
    }
    
    if([hat_condition choice] != nil) {
        if([hat_condition choice] == 1) {
            [FWGrab fromShelf:@"1000_hatrack" entity:@"1000_pinkhat" by:@"fiona"];
            if(at = hatchoicepoint+2000)
                [FWHat pink];
            //[FWClothing changeEntity:@"fiona" to:@"pinkhat"];
        }
        
        if([hat_condition choice] == 2) {
            [FWGrab fromShelf:"1000_hatrack" entity:@"1000_bluehat" by:@"fiona"];
            if(at = hatchoicepoint+2000)
                [FWHat blue];
            //[FWClothing changeEntity:@"fiona" to:@"bluehat"];
        }
    }
    
    if(at == hatchoicepoint+4000) {
        [FWLine display:@"13000"];
    }
    
    if(at == hatchoicepoint+5100) {
        [FWLine display:@"14000"];
    }
    if(at == hatchoice+5300)
        [FWDestination forEntity:@"fiona" isMarker:@"1000_frontporch"];
    if(at == hatchoicepoint+5500) {
        [FWLine display:@"15000"];
    }
}
@end
