//
//  FWSatchel.m
//  Fiona's Walk
//
//  Created by Kyle Reynolds on 2/20/12.
//  Copyright (c) 2012 The Canvas Foundation. All rights reserved.
//

#import "FWSatchel.h"
#import "common/FWInventory.h"
#import "common/FWSpawn.h"

@implementation FWSatchel

static FWInventory* sticky_notes;

-(id)init {
    sticky_notes = [[FWInventory alloc]initWithMaxItems:99 andMaxPerItem:1];
}


+(id)sharedSatchel {
    static FWSatchel* sharedInstance;
    
    @synchronized (self) {
        if(!sharedInstance){
            sharedInstance = [[self alloc] init];
        }
    }
    return sharedInstance;
}

+(void)add:(NSString*)userNote {
    [sticky_notes add:userNote ofQuantity:1];
}

+(void)use:(NSString*)userNote {
    [sticky_notes use:userNote ofQuantity:1];
}

+(void)fly:(NSString *)userNote difficulty:(int)userDifficulty {
    [FWSpawn createEntityWithName:[@"stickynote_" stringByAppendingString:userNote]];
}
@end
