//
//  FWInventory.h
//  Fiona's Walk
//
//  Created by Kyle Reynolds on 2/17/12.
//  Copyright (c) 2012 The Canvas Foundation. All rights reserved.
//  FWInventory: Add materializes the object, give employs the law of conservation and transfers it from the world, transfer takes it from another inventory

//...Maybe I should rid this class of all materialization functions and have only transfer functions.
//Yeah.

#import <Foundation/Foundation.h>

@class FWEntity;
@class FWWorld;

static NSMutableArray* items;

@interface FWInventory : NSObject  {
    NSMutableArray* items;
    FWEntity* sync_location;
    int max_items;
    int max_per_item;
}

-(id)initWithMaxItems:(int)userMaxItems andMaxPerItem:(int)userMaxPerItem;

-(BOOL)setMaxItems;
-(BOOL)setMaxPerItem;
-(int)numberOf: (NSString*)userName;

-(BOOL)add: (NSString*)userEntityName ofQuantity:(int)userQuantity;
-(BOOL)give: (FWEntity*)userEntity;
-(BOOL)transfer: (NSString*)userEntityName fromInventory:(FWInventory*)userInventory ofQuantity:(int)userQuantity;

-(FWEntity*)use: (NSString*)userEntityName ofQuantity:(int)userQuantity;
-(BOOL)toss: (NSString*)userEntityName ofQuantity:(int)userQuantity;



@end
