//
//  FWInventory.m
//  Fiona's Walk
//
//  Created by Kyle Reynolds on 2/17/12.
//  Copyright (c) 2012 The Canvas Foundation. All rights reserved.
//

#import "FWInventory.h"
#import "engine/FWEntity.h"
#import "engine/FWWorld.h"

@implementation FWInventory

-(id)initWithMaxItems:(int)userMaxItems andMaxPerItem:(int)userMaxPerItem {
    items = [[NSMutableArray alloc] init];
    max_items = userMaxItems; 
    max_per_item = userMaxPerItem;
    return self;
}

-(int)numberOf:(NSString*)userName {
    int count = 0;
    for(id entity in items) {
        if([[entity name] isEqualToString:userName])
            count++;
    }
    return count;
}

-(BOOL)add:(NSString*)userEntityName ofQuantity:(int)userQuantity {
    for(int i = 0; i < userQuantity; i++) {
        if([self numberOf: userEntityName] <= max_per_item)
            [items addObject: [[FWEntity alloc] initWithName:userEntityName]];
        
        else
            return false;
    }        
    return true;
}

-(BOOL)give: (FWEntity*)userEntity {
    if([self numberOf: [userEntity name]] <= max_per_item) {
        [items addObject: userEntity];
        return true;
    }
    else return false;
}

-(BOOL)use:(NSString*)userEntityName ofQuantity:(int)userQuantity {
    BOOL exists = ([self numberOf:userEntityName] > 0);
    BOOL keyitem = false;
    
    for(id entity in items) {
        if([entity attribute:@"keyitem" is:@"true"])
            keyitem = true;
    }

    if(exists && !keyitem)
        return [self toss:userEntityName ofQuantity:userQuantity];
}

-(BOOL)toss:(NSString*)userEntityName ofQuantity:(int)userQuantity {
    int count = 0;
    for(id entity in items) {
        if([[entity name] isEqualToString:userEntityName] && count < userQuantity) {
            [items removeObject:entity];
            count++;
        }        
        else
            return NO;
    }
    return YES;
}

-(BOOL)transfer:(NSString*)entityNamed fromInventory:(FWInventory*)userInventory ofQuantity:(int)userQuantity {

}
@end