//
//  FWEntity.m
//  Fiona's Walk
//
//  Created by Kyle Reynolds on 2/24/12.
//  Copyright (c) 2012 The Canvas Foundation. All rights reserved.
//

#import "FWEntity.h"

@implementation FWEntity

-(NSString*)attribute:(NSString *)userAttributeSearch {
    return [attributes valueForKey:userAttributeSearch];
}

-(id)initWithName:(NSString*)userEntityName {
    name = userEntityName;
    file = [self getFileFromName:userEntityName];
    attributes = [[NSMutableDictionary alloc] initWithContentsOfFile:file];
    prototype = [self attribute:@"prototype"]; //not really necessary?
    formatter = [[NSNumberFormatter alloc] init];
    return self;
}

-(NSString*)getFileFromName:(NSString*)userMasterName {
    return [working_directory stringByAppendingString:userMasterName];
}

-(void)setAttribute: (NSString*)userAttribute to:(NSString*)userValue {
    [attributes setValue:userValue forKey:userAttribute];
}

-(BOOL)attribute:(NSString*)userAttribute is:(NSString *)userValue {
    numberstore = [formatter numberFromString:userValue];
    if([attributes objectForKey:(userAttribute)]) {
        if(numberstore != nil)
            return ([attributes valueForKey:userAttribute] == numberstore);
    
        return ([[attributes valueForKey:userAttribute] isEqualToString:userValue]);
    }
    return NO;
}

@synthesize prototype;
@synthesize name;

@end
